; Where. Extracted and modified from DP's IDIS0 toolkit
;  Digital Precision, 1986(?)
;
; V0.01, pjw, 2025 Apr 07
;

        section code

        xdef WHERE
        xref chan_d6

err_bp
        moveq #-15,d0

exit
        rts

*
WHERE
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* WHERE [#channel,] <partial keyword name>
*
* Outputs all keywords that match the partial search term
*

        moveq #1,d6                    default channel no.
        bsr     chan_d6                returns channel ID in a0

        movea.l a0,a4
        cmpa.l  a3,a5
          beq.s err_bp

        movea.w $00000116,a2
        jsr     (a2)
          bne.s exit

        subq.w  #$01,d3
          bne.s err_bp

        moveq   #$00,d5
        move.w  $00(a6,a1.l),d5        get len
          beq.s L008E                  view all

        lea     $02(a6,a1.l),a3        -> string
        lea     L031C,a2
        movea.l a3,a5
        move.w  d5,d1
        subq.w  #$01,d1
L0072   cmpi.b  #$60,(a5)
          blt.s L007C

        subi.b  #$20,(a5)
L007C   move.b  (a5)+,(a2)+
        dbf     d1,L0072

        move.l  d5,d1
        addq.l  #3,d1
        bclr    #0,d1

L008C   adda.l  d1,a1

L008E   adda.l  #$00000002,a1
        move.l  a1,$0058(a6)
L0098   movea.l a4,a0
        bsr     L014C

        moveq   #$00,d4
L00A0   addq.l  #$08,d4
        movea.l $0018(a6),a4
        movea.l $001C(a6),a2
        movea.l a2,a5
        suba.l  d4,a5
        cmpa.l  a5,a4
          bgt.s L00DC

        move.w  $00(a6,a5.l),d1
        cmpi.w  #$0800,d1
          blt.s L00A0

        movea.l $04(a6,a5.l),a4
        lea     L0314,a1
        move.l  a4,(a1)
        movea.l #$00000000,a4
        movea.w $02(a6,a5.l),a4
        adda.l  $0020(a6),a4
        bsr.s   L00E0

        tst.l   d0
          bne.s L00DE
        bra.s   L00A0

L00DC   moveq   #$00,d0
L00DE   rts
; 
L00E0   move.b  $00(a6,a4.l),d2
        ext.w   d2
        move.w  #-$0001,d3
        movea.l a6,a1
        adda.l  a4,a1
        addq.l  #$01,a1
        cmp.w   #$0000,d5
          beq.s L0102
        cmp.b   d5,d2
          blt.s L015A
        bsr.s   L015C

        tst.l   d0
          beq.s L015A
L0102   moveq   #$07,d0         * IOB_SMUL
        trap    #$03
        tst.l   d0
          bne.s L015A

        move.w  #$0011,d0
        sub.w   d2,d0
        move.w  d0,d2
          ble.s L0120

        moveq   #$07,d0         * IOB_SMUL
        lea     L0302,a1
        trap    #$03
        tst.l   d0
          bne.s L015A

L0120   move.w  $00(a6,a5.l),d1
        cmp.w   #$0800,d1
          beq.s L0134

        lea     L02FE,a1
        move.w  #$000D,d2
        bra.s   L013C

L0134   lea     L02F0,a1
        move.w  #$000D,d2
L013C   moveq   #$07,d0         * IOB_SMUL
        trap    #$03
        tst.l   d0
          bne.s L015A
        bsr.s   L01E2

        tst.l   d0
          bne.s L015A

L014C   moveq   #-$01,d3
        move.l  a1,-(a7)
        moveq   #$05,d0         * IOB_SBYT
        move.b  #$0A,d1
        trap    #$03
        movea.l (a7)+,a1
L015A   rts

L015C   movem.l d3-d4/d6/a2/a4-a5,-(a7)
        lea     L031C,a3
        move.w  d2,d3
        sub.w   d5,d3
        addq.w  #$02,d3
        moveq   #$01,d7
        movea.l a1,a5
L016E   movea.l a3,a4
        move.b  (a4),d6
        addq.l  #$01,a4
L0174   addq.w  #$01,d7
        cmp.w   d7,d3
          blt.s L0194

        cmp.b   (a5)+,d6
          bne.s L0174

        movea.l a5,a2
        subq.l  #$01,a2
        subq.l  #$01,a4
        move.w  d5,d6
        subq.w  #$01,d6

L0188   cmpm.b  (a4)+,(a2)+
          bne.s L016E
        dbf     d6,L0188

        moveq   #$01,d0
        bra.s   L0196

L0194   moveq   #$00,d0
L0196   movem.l (a7)+,d3-d4/d6/a2/a4-a5
        rts
;
L01E2   movea.l a0,a4
        movea.l (a6),a0
        movea.l $0058(a6),a1
        lea     L0314,a5
        subq.l  #$04,a1
        move.l  (a5),$00(a6,a1.l)
        move.l  a0,(a5)
        movea.w $000000FE,a2
        jsr     (a2)
        move.l  a0,d2
        sub.l   L0314,d2
        subq.l  #$01,d2
        movea.l L0314,a1
        adda.l  a6,a1
        addq.l  #$01,a1
        move.b  #$24,(a1)
        movea.l a4,a0
        moveq   #-$01,d3
        moveq   #$07,d0         * IOB_SMUL
        trap    #$03
        rts
; 
L02F0   dc.b    '(PROC)        '
L02FE   dc.b    '(FN)'
L0302   dc.b    '                  '
L0314   dc.l    $00000000,$00000000
L031C   dc.l    $00000000,$00000000,$00000000,$00000000
        dc.l    $00000000,$00000000,$00000000,$00000000


*
        end
